
QGIS Application - Bug report #10000

Cannot use osm layers (no features?)

2014-04-05 10:17 AM - Anita Graser

Status: Closed

Priority: Normal

Assignee: Victor Olaya

Category: Processing/QGIS

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 18490

Description

Loaded an .osm file using Add Vector layer. When trying to use the layer with ftools tools, the following error is shown:

Uncaught error while executing algorithm

Traceback (most recent call last):

Traceback (most recent call last):

  File "C:/Users/Anita/.qgis2/python/plugins\\processing\\core\\GeoAlgorithm.py", line 202, in execute

    self.processAlgorithm(progress)

  File "C:/Users/Anita/.qgis2/python/plugins\\processing\\algs\\ftools\\FixedDistanceBuffer.py", line 79, in processAlgorithm

    dissolve, segments)

  File "C:/Users/Anita/.qgis2/python/plugins\\processing\\algs\\ftools\\Buffer.py", line 46, in buffering

    total = 100.0 / float(len(features))

ValueError: __len__() should return >= 0

History

#1 - 2014-06-03 01:32 AM - Richard Duivenvoorde

Hi Anita,

I think this is a bug in the osm provider (does osm have it's own provider)?

If you look into the 'Metadata'-properties of an 'osm'-layer, you see at 'Then number of features in this layer' the value -1

Also if I run one of my scripts it does not do anything, because you do not retrieve features back from this layer...

Trying out to the dat from this one:

wget -O muenchen.osm "http://api.openstreetmap.org/api/0.6/map?bbox=11.54,48.14,11.543,48.145"

While QGIS is showing me a lot of points, if I open the attribute table I do see just two.

So I would close this one (as it is not a processing issue), and open one at QGIS for osm data

(off course error handling can always be better, but that's another issue :-) )

#2 - 2014-06-03 02:32 AM - Anita Graser
Sure, feel free to open a new ticket or I can change this one to address the provider issue if that's more suitable?

#3 - 2014-06-03 04:12 AM - Richard Duivenvoorde

Ok, created this one: #10427

I would close this one.

#4 - 2014-06-03 05:39 AM - Giovanni Manghi

Richard Duivenvoorde wrote:

Hi Anita,

I think this is a bug in the osm provider (does osm have it's own provider)?

If you look into the 'Metadata'-properties of an 'osm'-layer, you see at 'Then number of features in this layer' the value -1

Also if I run one of my scripts it does not do anything, because you do not retrieve features back from this layer...

Trying out to the dat from this one:

wget -O muenchen.osm "http://api.openstreetmap.org/api/0.6/map?bbox=11.54,48.14,11.543,48.145"

While QGIS is showing me a lot of points, if I open the attribute table I do see just two.

So I would close this one (as it is not a processing issue), and open one at QGIS for osm data

(off course error handling can always be better, but that's another issue :-) )

I think it is an OGR issue or a dataset one

@giovanni@sibirica ~/Desktop $ ogrinfo muenchen.osm points

Had to open data source read-only.

INFO: Open of `muenchen.osm'

      using driver `OSM' successful.

Layer name: points

Geometry: Point

Feature Count: -1
Extent: (11.540000, 48.140000) - (11.543000, 48.145000)

Layer SRS WKT:

GEOGCS["WGS 84",

    DATUM["WGS_1984",

        SPHEROID["WGS 84",6378137,298.257223563,

            AUTHORITY["EPSG","7030"]],

        TOWGS84[0,0,0,0,0,0,0],

        AUTHORITY["EPSG","6326"]],

    PRIMEM["Greenwich",0,

        AUTHORITY["EPSG","8901"]],

    UNIT["degree",0.0174532925199433,

        AUTHORITY["EPSG","9108"]],

    AUTHORITY["EPSG","4326"]]

osm_id: String (0.0)

name: String (0.0)

barrier: String (0.0)

highway: String (0.0)

ref: String (0.0)

address: String (0.0)

is_in: String (0.0)

place: String (0.0)

man_made: String (0.0)

other_tags: String (0.0)

OGRFeature(points):398692

  osm_id (String) = 398692

  name (String) = (null)

  barrier (String) = (null)

  highway (String) = traffic_signals

  ref (String) = (null)

  address (String) = (null)

  is_in (String) = (null)

  place (String) = (null)

  man_made (String) = (null)

  other_tags (String) = "crossing"=>"traffic_signals" 

  POINT (11.5414971 48.1452196)

OGRFeature(points):1956100

  osm_id (String) = 1956100

  name (String) = (null)

  barrier (String) = (null)

  highway (String) = traffic_signals
  ref (String) = (null)

  address (String) = (null)

  is_in (String) = (null)

  place (String) = (null)

  man_made (String) = (null)

  other_tags (String) =

"crossing"=>"traffic_signals","TMC:cid_58:tabcd_1:Class"=>"Point","TMC:cid_58:tabcd_1:Direction"=>"positive","TMC:cid_58:tabcd_1:LCLversion"=>"9.00","TMC:cid_58:tabcd_1:

0","TMC:cid_58:tabcd_1:LocationCode"=>"35356","TMC:cid_58:tabcd_1:NextLocationCode"=>"35357","TMC:cid_58:tabcd_1:PrevLocationCode"=>"35355" 

55" 

  POINT (11.5487963 48.1434822)

@

#5 - 2014-06-03 11:26 AM - Anita Graser

Sorry, I'm confused now.

Considering  

ogrinfo lisdodde.osm -sql "SELECT COUNT(*) FROM points"

works as Richard stated in #10427, is it now an OGR issue or a QGIS issue?

#6 - 2014-06-04 04:59 AM - Richard Duivenvoorde

Yep, and also on muenchen.osm:

ogrinfo muenchen.osm -sql "SELECT COUNT(*) FROM points" 

Had to open data source read-only.

INFO: Open of `muenchen.osm'

      using driver `OSM' successful.

Layer name: points

Geometry: Point

Feature Count: 1

Layer SRS WKT:

(unknown)

COUNT_*: Integer (0.0)

OGRFeature(points):0

  COUNT_* (Integer) = 185

and QGIS is showing thos 185 points on the MapCanvas, but it looks like it is not exporting them to metadata or python interface???

#7 - 2014-06-04 11:18 PM - Jukka Rahkonen

I had a test with GDAL-dev (2.0) on Win7-64 with data captured with the same URL. I get also the "ERROR 1: Non increasing node id. Use

OSM_USE_CUSTOM_INDEXING=NO" errors. I believe they are right messages and the service really returns OSM data so that node ids are not in

increasing order. To get rid of the messages use set the config option as suggested:

>ogrinfo -al -so map.osm --config OSM_USE_CUSTOM_INDEXING NO
It is true that GDAL reports the number of features on the layer as unknown even it is able to count the correct number with SQL.

INFO: Open of `map.osm' using driver `OSM' successful.

Layer name: points

Geometry: Point

Feature Count: -1

Perhaps this is because of the structure of OSM data which makes it possible to tell the exact number of features only after everything has been parsed.

Does QGIS rely on this Feature Count somehow? In this case it obviously shouldn't.

#8 - 2014-10-04 11:48 AM - Giovanni Manghi

- Affected QGIS version set to 2.4.0

- Crashes QGIS or corrupts data set to No

- Category deleted (61)

- Project changed from 78 to QGIS Application

#9 - 2014-10-04 11:49 AM - Giovanni Manghi

- Category set to Processing/QGIS

#10 - 2015-10-10 12:39 AM - Anita Graser

- Target version set to Future Release - Lower Priority

- Affected QGIS version changed from 2.4.0 to master

This issue still persists.

Note: If there is a selection on the OSM layer, then it works. If there is no selection, it throws the error. So a workaround for users currently would be to just

select all features in the layer.

#11 - 2017-05-01 01:08 AM - Giovanni Manghi

- Easy fix? set to No

- Regression? set to No

#12 - 2019-03-09 04:04 PM - Giovanni Manghi

- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

#13 - 2019-03-09 04:59 PM - Anita Graser

- Resolution changed from end of life to fixed/implemented

- Description updated

Seems fixed in 3.7
